---
---  \file wrap_iarray2.lua
---  \brief Lua  wrapper for 2D itype Arrays
---
---


ia2Cols=function(a)
	  local cols={}
	  for i=1,a2NCol(a) do
	     tinsert(cols,a2Col(a,i))
	  end
	  return col
       end

ia2Rows=function(a)
	  local rows={}
	  for i=1,a2NRow(a) do
	     tinsert(rows,a2Row(a,i))
	  end
	  return rows
       end

-------------------------------------------------------------------------------
--- \LuaOnly Construct 2D double array from constructor table.
--- 
--+ IArray2 * IArray2(table desc);
--- 
function IArray2(desc)
   local fill=0,nrow,ncol,a
   if not desc then
      return nil
   elseif istype(desc,"IArray2") then
      return desc
   elseif desc.nrow and desc.ncol then
      a=mbase.ia2Create(desc.nrow, desc.ncol)
   elseif table.getn(desc)>0 and table.getn(desc[1])>0 then
      nrow=table.getn(desc)
      ncol=table.getn(desc[1])
      fill=1
      a=mbase.ia2Create(nrow,ncol)
   elseif desc.ncol then
      a=mbase.ia2Create(0,desc.ncol)
   else
      a=mbase.ia2Create(0,0)
   end
   if fill==1 then
      local i,j
      for i=1,nrow do
	 for j=1,ncol do
	    mbase.ia2Set(a,i,j,desc[i][j])
	 end
      end
   end
   return a
end


if not _array2 then _array2={} end
_array2["int"]=IArray2

--[[
IArray2.__index_old=IArray2.__index;

function IArray2.__index(v,idx) 
   if type(idx)=="number" then
      return ia2XRowVal(v,idx).v
   else
      return IArray2.__index_old(v,idx)
   end
end



IArray2.addref=ia2Addref
IArray2[".eq"]=doteq
getmetatable(IArray2)["__call"]=callnew
getmetatable(IArray2)["__eq"]=nil -- class equality problem in tolua ?
]]
