import "math"
using "mgraphic"
processargs(arg)
w=800
h=800
x=0
y=0

xmin=-2
xmax=2
ymin=-2 
ymax=2
zmin=-2
zmax=2
scale=1.0
fontsize=14

assignvalues(arg)
file=arg.files[1]

if arg.switches.help or not file then
   print[[
	 
      pdelib2 gldraw [options] file
      
      Draw OpenGL graphics described in Lua file.

Options: 
      Window data

      w=...  width
      h=...  height
      x=...  x offset
      y=...  y offset
      
      Volume data
      xmin=... 
      xmax=...
      ymin=...
      ymax=...
      zmin=...
      zmax=...
      scale=...
      
      fontsize=...

]]
os.exit()
end




xmin=xmin*scale
ymin=ymin*scale
zmin=zmin*scale

xmax=xmax*scale
ymax=ymax*scale
zmax=zmax*scale

viewer=glvCreate(x,y,w,h,file)
glvAddSubMenuEntry(viewer,
		   "File",
		   "Redraw",
		   524288+114,
		   0,1)

--glvRedecorate(viewer)

glFont(1, fontsize)

glvSetVolume3D(viewer,xmin,xmax,ymin,ymax,zmin,zmax);

function draw(viewer)
   s=loadfile(file)
   print (s,file)
   if s then s() end
end



glvSetObject(viewer,draw,nil)
glvWait()

  

