need("mldf")

---
---  \file wrap_mldf.lua
---  \brief Lua code for ldf.
--- 

-----------------------------
--- \brief
--- \luaonly Data handler 
--- Data table looks like this:
--- {file=string, pos=num, encoding="xdr"}
--+ table Data(table desc);
---
function  Data(desc)
   local file,pos
   ldf_binhandler=nil
   if type(desc)~="table" then return nil end
   if table.getn(desc)==0 then return nil end
   if desc.file then
      local f=io.open(desc.file,"r")
      if not f then return nil end
      f:close()
   end
   if table.getn(desc)==1 then -- Read into one array
      if desc.string then 
	 shRead(desc,desc.string) 
	 return desc[1]
      end 
      file=desc.file
      if not file then file="this" end
      if not desc.pos then pos=0 else pos=desc.pos end
      _ldf_userdata=desc[1]
      _ldf_delimiter=desc.delim
	if desc.encoding and desc.encoding=="xdr" then
          _ldf_binhandler=arrayldf_xdrhandler(desc[1])  -- more types to come: native, base64...
	else
         _ldf_linehandler=arrayldf_linehandler(desc[1])
        end
      if file~="this" then dofile(file,pos) end
      return desc[1]
   end
   if table.getn(desc) >1 then
      if desc.string then 
	 shRead(desc,desc.string) 
	 return desc
      end 
      file=desc.file
      if not file then file="this" end

      _ldf_userdata=desc
      _ldf_linehandler=shLineHandler
      _ldf_delimiter=desc.delim
      if file~="this" then dofile(file) end
      return desc
   end
   
end


 


-- be able to call Table() instead of Table:new()


-- TODO: cleanup, (tolua specific ?, but check before!!)
function callnew(obj,...) 
   return obj:new(unpack(arg))
end

-- TODO: cleanup, (tolua specific ?)
doteq=function(a1,a2)
	 if tostring(a1)==tostring(a2) then return true else return false end
      end

-------------------------------------------------------------------
-- Lua itself is missing the printf function, so we define it 
-- here.
function printf(...) 
   return io.write(string.format(unpack(arg)))   
end



--
-- Two versions: const(t,name,val) 
-- const(name,val) --> const(_G,name,val)
-- 
-- TODO: cleanup, check if needed
function const(...)
   local t,name,val
   if table.getn(arg)==2 then
      t=_G
      name=arg[1]
      val=arg[2]
   elseif table.getn(arg)==3 then
      t=arg[1]
      name=arg[2]
      val=arg[3]
   end
   if getmetatable(t)==nil then 
      setmetatable(t,_cmt) 
   elseif getmetatable(t)~=_cmt then 
      error("table does not allow for constants")
   end
   if t[name] then t[name]=nil end
   if not t._constants  then t._constants={} end
   t._constants[name]=val
end


--setmetatable(_G,_cmt)
--_constants={}
-- TODO: cleanup, check if needed
function import(package)
   if _G[package] then 
      for name,value in pairs(_G[package]) do
	 _G[name]=value
      end
   else
      error("Package "..package.." not loaded")
   end
end

-- TODO: cleanup, check if needed
function constimport(package)
   local pkg=_G[package]
   if pkg then 
      for name,value in pairs(pkg) do
	 const(name,value)
      end
   else
      error("Package "..package.."not loaded")
   end
end



-- TODO: interfer wit .get/.set stuff of tolua ?
-- TODO: cleanup, check if needed
constimport=import



--------------------------------------------------------------------------------
-- 

-- Data sheet line handlers
-- lua based linehandlers for strings and array lists
-- C implementation would be good...
shLineHandler=function(sheet,iline,...)
		 for i=1,table.getn(arg) do 
		    if sheet[i] then
		       sheet[i][iline]=arg[i] 
		    end
		 end
	      end

shFinish=function(sheet)
	    for i=1,table.getn(sheet) do 
	       if sheet[i] and sheet[i].adjust then
		  sheet[i].adjust(sheet[i]) 
	       end
	    end
	 end


shRow=function(sheet,...)
	 if not  sheet.i then sheet.i=0 end
	 sheet.i=sheet.i+1
	 for i=1,table.getn(arg) do 
	    if sheet[i] then
	       sheet[i][sheet.i]=arg[i] 
		  end
	       end
	    end

shEnd=function(sheet)
	 for idx,val in sheet  do  
	--    if tag(val)==_dvtag then 
	--       dvAdjust(val) 
	--    end 
	 end
	 sheet.i=nil
      end


--  Read vector table from string or file
shRead=function(sheet,source)
	  if type(source)=="string" then
	     sheet._idx0=0
	     sheet._idx=1
	     nextline=function() 
			 sheet._idx0=sheet._idx+1
			 sheet._idx=string.find(source,"\n",sheet._idx+1)
			 if not sheet._idx then return nil end
			 return string.sub(source,sheet._idx0,sheet._idx-1)
		      end
	  else 
	     nextline=function()
			 return read(source)
		      end
	     end
	     
	     local strng=nextline()
	     while strng do
		if string.sub(strng,1,1)~="#"  then
		   local row={}
		   table.insert(row,sheet)
		   local s,i=string.gsub(strng,
				  "([%d+-eE]+)",
				  function(s)   table.insert(row,tonumber(s)) end
			       )
		   if i>0 then
		      shRow(unpack(row))
		   end
		end
		strng=nextline()
	     end
	     sheet._idx0=nil
	     sheet._idx=nil
	     shEnd(sheet)
	     return sheet
	  end

shReadf=function(sheet,fname)
	   local f=openfile(fname,"r") or error("unable to open file ".. fname) 
	   local ret=shRead(sheet,f)
	   closefile(f) 
		 return ret
	end

      -- TODO: transposed a[i][j] 
      Sheet=function(desc)
		  local sheet=desc
		  if desc.data then 
		     shRead(sheet,desc.data) 
		  elseif desc.file and type(desc.file)=="string" then
		  shReadf(sheet,desc.file) 
	       elseif desc.file then
		  shRead(sheet,desc.file) 
	       else
		  _ldf_userdata=sheet
		  _ldf_linehandler=shLineHandler
		  _ldf_delimiter=desc.delim
	       end
	       return sheet
	    end
      

using(mldf)

----
---- CHECKED RESP. NEW FOR SWIG

function first(...)
  for i=1,table.getn(arg) do
   if arg[i] then
    return arg[i]
   end
  end
  return nil
end




------------------------------------------------------------------
-- Function for checking if some globale variable
-- to be  used hidden  parameter has been set.
function mandatory (name)
   if _G[name]==nil then
      print("mandatory  "..name.." missing")
      os.exit(1)
   else
      print("mandatory  "..name.."=",tostring(_G[name]).." ok")
   end
end

------------------------------------------------------------------
-- Function for setting default parameters from a table
function default(params)
   for name,value in pairs(params) do
         if _G[name]==nil then
	    _G[name]=value 
	    print("    default  "..name.."="..tostring(_G[name]))
	 else
	    print("*** modified "..name.."="..tostring(_G[name]).."  ***")
	 end
   end
end

------------------------------------------------------------------
-- function to accumulate data in arrays and dump the
-- chunks sometimes.
function logger(fname)
   return {
      fname=fname,
      irec=0,
      log=function(self,row)
	     if not self.array then
		self.array=da2Create(0,table.getn(row))
		self.irec=1
	     end
	     for i=1,table.getn(row) do
		da2Insert(self.array,self.irec,i,row[i]) 
	     end
	     self.irec=self.irec+1
	  end,
      dump=function(self)
	      if self.array then
		 local f=fopen(self.fname,"a")
		 da2ADump(self.array,f)
		 fclose(f)
		 self.array=nil
	      end
	   end
   }
end

